Program Aeroport;

Uses Crt,Printer;

type

    pt_aterr = ^elem_aterr;


    tipo_aterr = Record
                  ID   : Word;
                  T ,
                  COMB : byte
                 End;

    elem_aterr = Record
                  dados : tipo_aterr;
                  next : pt_aterr
                 End;

    pt_dec = ^elem_dec;

    tipo_dec = Record
                ID : Word;
                T  : Byte
               End;

    elem_dec = Record
                dados : tipo_dec;
                next  : pt_dec
               End;

    pt_prateleira = ^prateleira;

    prateleira = Record
                  front,
                  rear  : pt_aterr;
                  tam   : Word
                 End;

    pt_fila = ^fila;

    fila = Record
             front,
             rear  : pt_dec;
             tam   : Word
           End;

    fila_aterrisagem = Array [1..2] of pt_prateleira;

    fila_decolagem   = pt_fila;

    Aeroporto = Record
                 Pista_Dec   : Array [1..3] of fila_decolagem;
                 Pista_Aterr : Array [1..2] of fila_aterrisagem;
                End;

Var
    Aeroporto1  : Aeroporto;
    P1,P2,P3    : Boolean;      {indicadores de pista ocupada}
    Externo,
    Interno     : integer;      {Contadores do Loop Principal}
    IDP,                        {Controle dos nros de identificacao pares}
    IDI         : Word;         {Controle dos nros de identificacao  impares}

    Chegada_aterr,   {nro de avioes que chegaram para aterrisar a cada U.T.}
    Chegada_dec,     {nro de avioes que chegaram para decolar a cada U.T.}
    {usados em Chegada_Pouso_Decolagem }

    Aterrisou,     {nro de avioes que aterrisaram normalmente a cada U.T.}
    Decolou,       {nro de avioes que decolaram a cada U.T.}
    Aterrisou_5UT, {nro de avioes que aterrisaram normalmente a cada 5 U.T.}
    Decolou_5UT,   {nro de avioes que decolaram a cada 5 U.T.}
    Tempo_acum_aterr, {acumula o tempo que cada aviao permaneceu na fila
                       para aterrisar, serve para computar a media do
                       tempo de aterrisagem, emitida a cada 5 U.T.}
    Tempo_acum_dec, {                idem para decolagem              }
    {usados em processa_aterrisagem_e_decolagem.       }

    Aterrisou_emerg, {numero de avioes que aterrisaram sem reserva de
                      combustivel a cada U.T.                         }
    Queda,          {nro de avioes que cairam a cada U.T.             }
    Aterrisou_emerg_5UT, {nro de avioes que aterrisaram a cada 5 U.T.}
    {usados em Processa_Aterrisagem_Emergencia.   }

    Tempo_medio_aterr, {tempo medio de aterrisagem computado a cada 5 U.T.}
    Tempo_medio_dec    {tempo medio de decolagem computado a  cada 5 U.T.}
    {usados em emite_relatorio_5UT.                   }
                       : Word;



Procedure MakeNullA(q:pt_prateleira);
Begin
  q^.tam := 0;
  q^.front := nil;
  q^.rear:=q^.front;
End;

Procedure MakeNullD(q:pt_fila);
Begin
  q^.tam := 0;
  q^.front := nil;
  q^.rear:=q^.front;
End;

Function EmptyA(q:pt_prateleira):boolean;
Begin
  if (q^.front=nil) then EmptyA:=true
                      else EmptyA:=false;
End;

Function EmptyD(q:pt_fila):boolean;
Begin
  if (q^.front=nil) then EmptyD:=true
                      else EmptyD:=false;
End;

Function FrontA(q:pt_prateleira):pt_aterr;

Begin
  if EmptyA(q) then writeln('ERRO NO FRONTA!!!!')
               else Fronta:=q^.front;
End;

Function FrontD(q:pt_fila):pt_dec;

Begin
  if EmptyD(q) then writeln('ERRO NO FRONTD!!!')
               else Frontd:=q^.front;
End;

Procedure EnqueueA(q:pt_prateleira;x:tipo_aterr);
Var p:pt_aterr;

Begin
  new(p);
  p^.dados.ID:=x.ID;
  p^.dados.T:=x.T;
  p^.dados.COMB:=x.COMB;
  p^.next:=nil;
  if (q^.rear = nil) then
    Begin   { primeiro da fila}
     q^.rear:= p;
     q^.front:= p;
    End
   else
    Begin
     q^.rear^.next:=p;
     q^.rear:=p;
    End;
  Inc(q^.tam);

End;

Procedure EnqueueD(q:pt_fila;x:tipo_dec);
Var p:pt_dec;

Begin
  new(p);
  p^.dados.ID:=x.ID;
  p^.dados.T:=x.T;
  p^.next:=nil;
  if (q^.rear = nil) then
   Begin   { primeiro da fila}
    q^.rear:= p;
    q^.front:= p;
   End
  else
   Begin
    q^.rear^.next:=p;
    q^.rear:=p;
   End;
  Inc(q^.tam);
End;


Procedure DequeueA(q:pt_prateleira);
Var p:pt_aterr;

Begin
  if EmptyA(q) then writeln('ERRO NO DEQUEUEA!!!!')
               else
                Begin
                 p:=q^.front;
                 q^.front:=q^.front^.next;
                 if q^.front = nil then q^.rear:=nil; {Ultimo da Fila.}
                 Dispose(p);
                 Dec (q^.tam);
                End;
End;


Procedure DequeueD(q:pt_fila);
Var p:pt_dec;

Begin
  if EmptyD(q) then writeln('ERRO NO DEQUEUED!!')
               else
                Begin
                 p:=q^.front;
                 q^.front:=q^.front^.next;
                 if q^.front = nil then q^.rear := nil; {Ultimo da fila.}
                 Dispose(p);
                 Dec (q^.tam);
                End;

End;


Procedure Constroe_Aeroporto(Var a:Aeroporto);

Var I,J:integer;
    q : pt_prateleira;
    p : pt_fila;

Begin
  IDP := 0;
  IDI := 1;
  Tempo_acum_dec:=0;
  Tempo_acum_aterr:=0;
  Decolou_5UT:=0;
  Aterrisou_5UT:=0;
  Aterrisou_emerg_5UT:=0;
  Tempo_medio_dec:=0;
  Tempo_medio_aterr:=0;
  for I:=1 to 3 do
    Begin
      new(p); {Aloca o cabecalho da fila de decolagem.}
      a.Pista_Dec[I] := p;
      MakeNullD(a.Pista_Dec[i]);
    End;
  for I:=1 to 2 do
      for J:=1 to 2 do
       Begin
          new(q); {Aloca o cabeca da prateleira de aterrisagem.}
          a.Pista_Aterr[i,j] := q;
          MakeNullA(a.Pista_aterr[i,j]);
       End
End;

Procedure Delete(p:pt_prateleira;q:pt_aterr);

Var g:pt_aterr;

Begin
  g:=p^.front;
  if g = q then     {q = q^.front      Primeiro da fila.}
    Begin
     g := q^.next;
     dispose(q);
     p^.front := g;
     Dec(p^.tam);
    End
   else
    Begin
      while(g^.next<>q) do
         g:=g^.next;
      if q = p^.rear then p^.rear:=g; {ultimo da fila }
      g^.next:=q^.next;
      dispose(q);
      Dec(p^.tam);
    End;
End;


Procedure Chegada_Pouso_e_Decolagem(Var a: Aeroporto);
Var W:integer;
    I:byte;
    L:pt_prateleira;
    aux_at : tipo_aterr;
    aux_dec : tipo_dec;
    k:pt_fila;

Function Menor_A:pt_prateleira;
Var I,J,M:integer;
Begin
  M:=a.Pista_Aterr[1,1]^.tam;
  for I:=1 to 2 do
      for J:=1 to 2 do
          if a.Pista_aterr[i,j]^.tam <= M then{ Era <= ***************************}
             Begin
                Menor_A:=a.Pista_aterr[i,j];
                M:=a.Pista_aterr[i,j]^.tam;
             End;
End;

Function Menor_D:pt_fila;
Var I,M:integer;
Begin
  M:=a.Pista_Dec[1]^.tam;
  for I:=1 to 3 do
          if a.Pista_Dec[i]^.tam <= M then {Idem **************************}
             Begin
                Menor_D:=a.Pista_Dec[i];
                M:=a.Pista_Dec[i]^.tam;
             End;
End;

Begin  {Chegada_Pouso_e_Decolagem}
  Chegada_aterr := 0;
  Chegada_dec := 0;
  randomize;
  W:=round(random(4));
  Chegada_aterr := w;
  for I:=1 to W do
   Begin
     aux_at.ID:= IDI;
     aux_at.T := 0;
     Inc(IDI,2);
     aux_at.Comb:=round(random(19))+1;  {nao pode ser zero}
     L := Menor_A; {Seleciona a menor entre as prateleiras de aterrisagem.}
     Enqueuea(L,aux_at);
   End;
  W:=round(random(4));
  Chegada_dec := w;
  for I:=1 to W do
   Begin
     aux_dec.ID := IDP;
     aux_dec.T := 0;
     Inc(IDP,2);
     k:=Menor_D; {Seleciona a menor entre as filas de decolagem.}
     Enqueued(k,aux_dec);
   End;

End;  {Chegada_Pouso_e_Decolagem}


Procedure Atualiza_Combustivel_Tempo( Var a: Aeroporto);
Var
  p  : pt_prateleira;
  at : pt_aterr;
  q  : pt_fila;
  d  : pt_dec;
  I,J : Word;

Begin
  for I:=1 to 3 do {Filas decolagem}
    Begin
      q:= a.Pista_Dec[I];
      d:= q^.front;
      while (d <> nil) do
        Begin
          Inc(d^.dados.T);
          d:= d^.next;
        End
    End;
  for I:=1 to 2 do
    for J:=1 to 2 do    {Prateleiras de Aterrisagem}
      Begin
        p:=a.Pista_Aterr[I,J];
        at:=p^.front;
        while (at <> nil) do
          Begin
            Dec(at^.dados.COMB);
            Inc(at^.dados.T);
            at:= at^.next;
          End
      End
End; {Atualiza_Combustivel_Tempo}


Procedure Processa_Aterrisagem_Emergencia(Var a: Aeroporto);

Var  I,J      : integer;
     p        : pt_prateleira;
     q        : pt_aterr;

Procedure Aterrisa_emergencia(p:pt_prateleira;q:pt_aterr);
Begin
  if P3 then
         Begin
           P3:=false;
           Inc(Aterrisou_Emerg);
           Inc (Tempo_acum_aterr , q^.dados.T);
         End
 else
  if P1 then
         Begin
           P1:=false;
           Inc(Aterrisou_Emerg);
           Inc (Tempo_acum_aterr , q^.dados.T);
         End
 else
  if P2 then
         Begin
           P2:=false;
           Inc(Aterrisou_Emerg);
           Inc (Tempo_acum_aterr , q^.dados.T);
         End
  else
     Inc(Queda);
 Delete(p,q);
End;


Begin {Processa_Aterrisagem_Emergencia}
  Aterrisou_emerg := 0;
  Queda:=0;
  for I:=1 to 2 do
    for J:=1 to 2 do
      Begin
        p:=a.Pista_aterr[I,J];
        q:=p^.front;
        while(q<>nil) do
          Begin
            if q^.dados.COMB=0 then
                Aterrisa_Emergencia(p,q);
            q:=q^.next;
         End;
      End;
      Inc (Aterrisou_emerg_5UT, Aterrisou_emerg);
End; {Processa_Aterrisagem_Emergencia}


Procedure Processa_aterrisagem_e_Decolagem(Var a :Aeroporto);

Begin
  P1 := true;
  P2 := true;
  P3 := true;
  Processa_Aterrisagem_Emergencia(a);
  Aterrisou := 0;
  Decolou := 0;
  if P1 then
   Begin
     P1 := false;
     if (a.Pista_Aterr [1,1]^.tam >= a.Pista_Aterr [1,2]^.tam)
           and (a.Pista_Aterr [1,1]^.tam <> 0) then
       if (a.Pista_Aterr [1,1]^.tam >= a.Pista_Dec [1]^.tam) then
         Begin {Aterrisa na prateleira 1 da pista 1.}
           Inc(Aterrisou);
           Inc(Tempo_acum_aterr, a.Pista_Aterr [1,1]^.front^.dados.T);
           DequeueA(a.Pista_Aterr[1,1]);
         End
       else
         Begin {Decola da pista 1}
           Inc(Decolou);
           Inc(Tempo_acum_dec, a.Pista_Dec[1]^.front^.dados.T);
           DequeueD(a.Pista_Dec[1]);
         End
   else { prat-2 da pista-1 > prat-1 da pista-1}
     Begin {Aterrisa da prateleira 2 da pista 1}
       if (a.Pista_Aterr[1,2]^.tam >= a.Pista_Dec[1]^.tam)
            and (a.Pista_Aterr[1,2]^.tam <> 0)then
         Begin
           Inc(Aterrisou);
           Inc(Tempo_acum_aterr, a.Pista_Aterr [1,2]^.front^.dados.T);
           DequeueA(a.Pista_Aterr[1,2]);
         End
       else
         if (a.Pista_Dec[1]^.tam <> 0) then
           Begin {Decolar da pista 1}
             Inc(Decolou);
             Inc(Tempo_acum_dec, a.Pista_Dec[1]^.front^.dados.T);
             DequeueD(a.Pista_Dec[1]);
           End
     End
   End;
  if P2 then
   Begin
     P2 := false;
     if (a.Pista_Aterr [2,1]^.tam >= a.Pista_Aterr [2,2]^.tam)
         and (a.Pista_Aterr [2,1]^.tam <> 0) then
       if (a.Pista_Aterr [2,1]^.tam >= a.Pista_Dec [2]^.tam) then
         Begin {Aterrisar da prateleira 1 da pista 2}
           Inc(Aterrisou);
           Inc(Tempo_acum_aterr, a.Pista_Aterr [2,1]^.front^.dados.T);
           DequeueA(a.Pista_Aterr[2,1]);
         End
       else
         Begin {Decolar da pista 2}
           Inc(Decolou);
           Inc(Tempo_acum_dec, a.Pista_Dec[2]^.front^.dados.T);
           DequeueD(a.Pista_Dec[2]);
         End
   else { prat-2 da pista-2 > prat-1 da pista-2}
     Begin
       if(a.Pista_Aterr[2,2]^.tam >= a.Pista_Dec[2]^.tam)
           and (a.Pista_Aterr[2,2]^.tam <> 0)then
         Begin
           Inc(Aterrisou);
           Inc(Tempo_acum_aterr, a.Pista_Aterr [2,2]^.front^.dados.T);
           DequeueA(a.Pista_Aterr[2,2]);
         End
       else
         if (a.Pista_Dec[2]^.tam <> 0) then
           Begin {Decolar da pista 2}
             Inc(Decolou);
             Inc(Tempo_acum_dec, a.Pista_Dec[2]^.front^.dados.T);
             DequeueD(a.Pista_Dec[2]);
           End
     End
   End;
  if P3 and (a.Pista_Dec[3]^.tam <> 0) then
    Begin {Decolar da pista 3}
      P3 := false;
      Inc(Decolou);
      Inc(Tempo_acum_dec, a.Pista_Dec[3]^.front^.dados.T);
      DequeueD(a.Pista_Dec[3]);
    End;
  Inc(Aterrisou_5UT, Aterrisou);
  Inc(Decolou_5UT, Decolou);

End; {Processa_Aterrisagem_e_Decolagem}


Procedure Emite_relatorio_UT(Var a:Aeroporto);
Var c : char;
Begin
 writeln(' SITUACAO DO AEROPORTO NA UNIDADE DE TEMPO ');
 writeln('1)Numero de avioes que chegaram para aterrisar = ',Chegada_aterr:2);
 writeln('2)Numero de avioes que chegaram para decolar   = ',Chegada_dec:2);
 writeln('3)Numero de avioes que aterrisaram com reserva de combustivel = ',Aterrisou:2);
 writeln('4)Numero de avioes que aterrisaram sem reserva de combustivel = ',Aterrisou_Emerg:2);
 writeln('5)Numero de avioes que decolaram = ',Decolou:2);
 writeln('6)Numero de acidentes ( avioes que cairam ) = ',Queda:2);
 writeln(' SITUACAO DE ESPERA NAS PISTAS ');
 writeln(' Lista de espera para Pista 1:');
 writeln('      Prateleira 1 = ',a.Pista_aterr[1][1]^.tam:2);
 writeln('      Prateleira 2 = ',a.Pista_aterr[1][2]^.tam:2);
 writeln('      Decolagem    = ',a.Pista_dec[1]^.tam:2);
 writeln(' Lista de espera para Pista 2:');
 writeln('      Prateleira 1 = ',a.Pista_aterr[2][1]^.tam:2);
 writeln('      Prateleira 2 = ',a.Pista_aterr[2][2]^.tam:2);
 writeln('      Decolagem    = ',a.Pista_dec[2]^.tam:2);
 writeln(' Lista de espera para Pista 3:');
 writeln('      Decolagem    = ',a.Pista_dec[3]^.tam:2);
 c:= readkey;
End;



Procedure Emite_Relatorio_5UT(Var a:Aeroporto);
Var c: char;

Procedure Imprime_Situacao_Aeroporto;
 Var
   p  : pt_prateleira;
   at : pt_aterr;
   q  : pt_fila;
   d  : pt_dec;
   I,J : Word;

 Begin
   for I:=1 to 3 do {Filas decolagem}
     Begin
       q:= a.Pista_Dec[I];
       d:= q^.front;
       writeln (Lst);
       writeln('Conteudo da Pista de Decolagem  ',i);
       while (d <> nil) do
         Begin
           writeln('ID = ',d^.dados.ID);
           d:= d^.next;
         End;
       c := readkey;
     End;
   for I:=1 to 2 do
     for J:=1 to 2 do    {Prateleiras de Aterrisagem}
       Begin
         p:=a.Pista_Aterr[I,J];
         at:=p^.front;
         writeln(Lst);
         writeln('Conteudo da Prateleira de Aterrisagem  ',J,'  Pista  ', I);
         while (at <> nil) do
           Begin
             writeln('ID = ',at^.dados.ID:3,' Combustivel = ', at^.dados.COMB:3);
             at:= at^.next;
           End;
      c:= readkey;
       End
 End;


Begin {Emite_Relatorio_5UT}
 writeln(' SITUACAO DO AEROPORTO APOS 5 UNIDADES DE TEMPO ');
 writeln(Lst);
 Imprime_Situacao_Aeroporto;
 if (Decolou_5UT <> 0) then
    Tempo_medio_dec:=round(Tempo_acum_dec/Decolou_5UT);
 if (Aterrisou_5UT+Aterrisou_emerg_5UT <> 0) then
    Tempo_medio_aterr:=round(Tempo_acum_aterr/
                         (Aterrisou_5UT+Aterrisou_emerg_5UT));
 if (Decolou_5UT = 0) then
   writeln('Nao Houve decolagens ')
 else
   writeln('  Tempo medio de espera para decolagem   = ',Tempo_medio_dec:2);
 if (Aterrisou_5UT+Aterrisou_emerg_5UT = 0) then
    writeln('Nao houve aterrisagens')
 else
    writeln('  Tempo medio de espera para aterrisagem = ',Tempo_medio_aterr:2);
 writeln('  Numero de avioes que aterrisaram');
 writeln('              sem reserva de combustivel = ',Aterrisou_emerg_5UT:2);
 writeln(Lst);
 Tempo_acum_dec:=0;
 Tempo_acum_aterr:=0;
 Decolou_5UT:=0;
 Aterrisou_5UT:=0;
 Aterrisou_emerg_5UT:=0;
 Tempo_medio_dec:=0;
 Tempo_medio_aterr:=0;


End;{Emite_Relatorio_5UT}


Begin {Programa Principal}
  Constroe_Aeroporto(Aeroporto1);
  for Externo:=1 to 4 do
    Begin
      for Interno:=1 to 5 do
        Begin
          Chegada_Pouso_e_Decolagem(Aeroporto1);
          Processa_Aterrisagem_e_Decolagem(Aeroporto1);
          Atualiza_Combustivel_Tempo(Aeroporto1);
          Emite_Relatorio_UT(Aeroporto1);
        End;
       Emite_Relatorio_5UT(Aeroporto1);
    End;
End.